/** @license Digigov v0.1.0
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import _extends from "@babel/runtime/helpers/extends";
import defaultParserInterface from 'astql/utils/defaultParserInterface';
import pkg from 'regexp-tree/package.json';
var ID = 'regexp-tree';
export default _extends({}, defaultParserInterface, {
  id: ID,
  displayName: ID,
  version: pkg.version,
  homepage: pkg.homepage,
  locationProps: new Set(['loc']),
  loadParser: function loadParser(callback) {
    require('astql/utils/multiple-require')(['regexp-tree'], function (regexpTree) {
      callback(regexpTree);
    });
  },
  parse: function parse(regexpTree, code) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    regexpTree.parser.setOptions(options);
    return regexpTree.parse(code);
  },
  nodeToRange: function nodeToRange(node) {
    if (node.loc != null) {
      return [node.loc.start, node.loc.end];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return node.type === 'RegExp' || key === 'body' || key === 'expressions';
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      captureLocations: true
    };
  }
});