"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defaultParserInterface = _interopRequireDefault(require("astql/utils/defaultParserInterface"));

var _package = _interopRequireDefault(require("regexp-tree/package.json"));

var ID = 'regexp-tree';

var _default = (0, _extends2.default)({}, _defaultParserInterface.default, {
  id: ID,
  displayName: ID,
  version: _package.default.version,
  homepage: _package.default.homepage,
  locationProps: new Set(['loc']),
  loadParser: function loadParser(callback) {
    require('astql/utils/multiple-require')(['regexp-tree'], function (regexpTree) {
      callback(regexpTree);
    });
  },
  parse: function parse(regexpTree, code) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    regexpTree.parser.setOptions(options);
    return regexpTree.parse(code);
  },
  nodeToRange: function nodeToRange(node) {
    if (node.loc != null) {
      return [node.loc.start, node.loc.end];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return node.type === 'RegExp' || key === 'body' || key === 'expressions';
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      captureLocations: true
    };
  }
});

exports.default = _default;